<?php
/*
Wax Poteto by Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 5.4.7 - Last modified 4/28/2005

Functions to create thumbnails
*/

function make_thumbnail($file_source, $file_dest) {
	global $jpgcompression;  // Turned on?
	global $jpgcompressqual; // Quality
	global $scale;     // Scale type
	global $scale_pix; // Scale size
	global $xDefault, $yDefault;

	// Like it says
	$scale_if_larger_than = ($xDefault + $yDefault) / 2;


	if ($jpgcompression != 'yes')
		return 1;

	// Get picture dimmentions and longer side
	// $long_mode ? vertical : horizontal
	$p_sizes = GetImageSize ($file_source);
	if ($p_sizes[0] < $p_sizes[1]) {
		$long_mode  = 1;
		$long_side  = $p_sizes[1];
		$short_side = $p_sizes[0];
	} else {
		$long_mode  = 0;
		$long_side  = $p_sizes[0];
		$short_side = $p_sizes[1];
	}

	// Get scaled size ($new_x, $new_y)
	$new_x = $p_sizes[0];
	$new_y = $p_sizes[1];
	switch ($scale) {
		case 1:
			if ($long_side > $scale_if_larger_than) {
				$new_x = round ($p_sizes[0] * .5);
				$new_y = round ($p_sizes[1] * .5);
			}
			break;
		case 2:
			if ($long_side > $scale_pix) {
				$ratio = $scale_pix / $long_side;
				$lesser_t = round ($short_side * $ratio);
				if ($long_mode == 0) {
					$new_x = $scale_pix;
					$new_y = $lesser_t;
				} else {
					$new_x = $lesser_t;
					$new_y = $scale_pix;
				}
			}
			break;
		default:
			$new_x = $p_sizes[0];
			$new_y = $p_sizes[1];
	}


	// GDlib is weird and inconsistent, so we'll have to remap some functions
	if (function_exists ('imagecreatetruecolor')) {
		$create_function = 'imagecreatetruecolor';
		$resize_function = 'imagecopyresampled';
	} else {
		$create_function = 'imagecreate';
		$resize_function = 'imagecopyresized';
	}

	// Make image
	if (file_exists ($file_dest) && !is_writable ($file_dest)) {
		if (!@unlink ($file_dest)) {
			return 0;
		}
	}
	$old_img = @imagecreatefrompng ($file_source);
	if ($old_img) {
		$new_img = @$create_function($new_x, $new_y);
		@$resize_function($new_img, $old_img, 0, 0, 0, 0, $new_x, $new_y, $p_sizes[0], $p_sizes[1]);
		@imagejpeg ($new_img, $file_dest, $jpgcompressqual);

		// Free memory -- or else!
		imagedestroy ($old_img);
		imagedestroy ($new_img);

		return 1;
	}

	return 0;
}

?>